unit screenshot_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ComCtrls, Buttons, ShellCtrls, StdCtrls,
  Process,
  Inifiles, //Fichier .ini
  LCLType, //HDC
  LCLIntf, FileCtrl; //GetDC -> Bitmap:=TBitmap.Create;...

const
  //Ini
  IniNom_ = 'ScreenShot.ini';

type

  { TWdMain }

  TWdMain = class(TForm)
    CkImg: TCheckBox;
    CkBmp: TCheckBox;
    CkJpeg: TCheckBox;
    EdPath: TEdit;
    Gr2: TGroupBox;
    GrOptions: TGroupBox;
    GrSauve: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Pa1: TPanel;
    Pa2: TPanel;
    Pa3: TPanel;
    PaExp: TPanel;
    SaveDialog1: TSaveDialog;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    Sp1: TSpeedButton;
    Sp2: TSpeedButton;
    Sp3: TSpeedButton;
    Sp4: TSpeedButton;
    SpAppl: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpPath: TSpeedButton;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure Sp1Click(Sender: TObject);
    procedure Sp2Click(Sender: TObject);
    procedure Sp3Click(Sender: TObject);
    procedure Sp4Click(Sender: TObject);
    procedure SpApplClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpPathClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdMain: TWdMain;
  DirExe:string;
  Dir:string;
  //
  ImageBureau:TPicture;
  JpegNb:integer;
  //Rapport écran
  Ratio:real;

implementation

Uses screenshot_dossier, screenshot_img, screenshot_aide;

{$R *.lfm}

{ TWdMain }

procedure Executer(s:string;Attente:boolean);
var
 AProcess:TProcess;
begin
 AProcess:=TProcess.Create(nil);
 AProcess.CommandLine:=s;
 //Executer jusqu'a fermeture
 if Attente then
  AProcess.Options:=AProcess.Options+[poWaitOnExit];
 AProcess.Execute;
 AProcess.Free;
end;

procedure Ratio_Ecran;
begin
  Ratio:=Screen.Width/Screen.Height;
end;

procedure Ini_Lire;
var
  FIni: TiniFile;
  Fichier: string;
begin
  with WdMain do
  begin
    Fichier := DirExe + IniNom_;
    if FileExists(Fichier) then
      with WdMain do
      begin
        FIni := TiniFile.Create(Fichier);
        //Chemin de sauvegarde
        Dir := FIni.ReadString('Path', 'Save', DirExe);
        if not FileExists(Dir) then
          Dir:=DirExe;
        //CheckBox
        CkJpeg.Checked := FIni.ReadBool('Check', 'Jpeg', True);
        CkBmp.Checked := FIni.ReadBool('Check', 'Bmp', false);
        CkImg.Checked := FIni.ReadBool('Check', 'Img', false);
        WdAide.CkAide.Checked := FIni.ReadBool('Check', 'Aide', false);
        //-
        Fini.Free;
      end;
  end;
end;

procedure Ini_Sauve;
var
  FIni: TiniFile;
begin
  with WdMain do
  begin
    FIni := TiniFile.Create(DirExe + IniNom_);
    //Chemin de sauvegarde
    FIni.WriteString('Path', 'Save', Dir);
    //CheckBox
    FIni.WriteBool('Check', 'Jpeg', CkJpeg.Checked);
    FIni.WriteBool('Check', 'Bmp', CkBmp.Checked);
    FIni.WriteBool('Check', 'Img', CkImg.Checked);
    FIni.WriteBool('Check', 'Aide', WdAIde.CkAide.Checked);
    Fini.Free;
  end;
end;

Procedure SaveScreenShot;
var
 vBMP:TBitmap;
 vDC :HDC;
begin
 vBMP:=TBitmap.Create;
 vDC:=GetDC(0);
 vBMP.LoadFromDevice(vDC);
 ReleaseDC(0,vDC);
end;

procedure ScreenShot_vers_Bmp_et_Jpeg(Select:integer);
var
 Bitmap  :TBitmap;
 JPGImage:TGraphic ;
 ScreenDC:HDC;
 SrcRect,DstRect:TRect;
 FileBmp:string;
 FileJpeg:string;
begin
  //Sauver la copie écran dans un fichier Jpeg
  try
    Bitmap:=TBitmap.Create;
    //Récupère le handle de la feuille
    //GetDC(handle) -> handle=0
    ScreenDC:=GetDC(0);
    Bitmap.LoadFromDevice(ScreenDC);
    //ReleaseDC(handle,ScreenDC);
    ReleaseDC(0,ScreenDC);
    //-
    JPGImage:=TJPegImage.Create;
    JPGImage.Assign(Bitmap);
    //Envoyer dans Fichier Jpeg
    With WdMain do begin
      //JpegNb = Compteur pour la sauvegarde
      Inc(JpegNb);
      //Sauvegardes
      if CkBmp.Checked then begin
        FileBmp:=Dir+'Copie écran-'+IntToStr(JpegNb)+'.bmp';
        Case Select of
          1:begin
            SaveDialog1.FileName:=ExtractFileName(FileBmp);
            if SaveDialog1.Execute then
              Bitmap.SaveToFile(FileBmp);
          end;
          else begin
            Bitmap.SaveToFile(FileBmp);
          end;
        end;
      end;
      if CkJpeg.Checked then begin
        FileJpeg:=Dir+'Copie écran-'+IntToStr(JpegNb)+'.jpg';
        Case Select of
          1:begin
            SaveDialog1.FileName:=ExtractFileName(FileJpeg);
            if SaveDialog1.Execute then
              JPGImage.SaveToFile(FileJpeg);
          end;
          else begin
            JPGImage.SaveToFile(FileJpeg);
          end;
        end;
      end;
      //-
      With WdDossier do begin
        ShellTreeView1.Path:='C:\';
        ShellTreeView1.Path:=Dir;
      end;
      //Affichage du ScreenShot
      Ratio_Ecran;
      With WdImg do begin
        Height:=Round(Width/Ratio)+4;
        if CkImg.Checked then begin
          if FileExists(FileJpeg) then begin
            Caption:=FileJpeg;
            Img.Picture.LoadFromFile(FileJpeg);
            Show;
          end else begin
            if FileExists(FileBmp) then begin
              Caption:=FileBmp;
              Img.Picture.LoadFromFile(FileBmp);
              ShowModal;
            end;
          end;
        end;
      end;
    end;
  finally
    Bitmap.free;
    JpgImage.Free;
  end;
end;

procedure TWdMain.Sp1Click(Sender: TObject);
begin
  Application.Minimize;
  Sleep(300);
  Timer1.Enabled:=true;
  ScreenShot_vers_Bmp_et_Jpeg(0);
  Application.Restore;
end;

procedure TWdMain.Sp2Click(Sender: TObject);
begin
  Application.Minimize;
  Sleep(300);
  Timer1.Enabled:=true;
  ScreenShot_vers_Bmp_et_Jpeg(1);
  Application.Restore;
end;

procedure TWdMain.Sp3Click(Sender: TObject);
begin
  With WdDossier do begin
    ShellTreeView1.Path:=Dir;
    ShowModal;
    Dir:=ShellTreeView1.Path;
    EdPath.Text:=Dir;
  end;
end;

procedure TWdMain.Sp4Click(Sender: TObject);
begin
  Executer('explorer.exe '+Dir,false);
end;

procedure TWdMain.SpApplClick(Sender: TObject);
begin
  Dir:=DirExe;
  EdPath.Text:=Dir;
end;

procedure TWdMain.SpeedButton1Click(Sender: TObject);
begin
  WdAide.ShowModal;
end;

procedure TWdMain.SpPathClick(Sender: TObject);
begin
  With SelectDirectoryDialog1 do begin
    filename:=Dir;
    if Execute then begin
      Dir:=FileName;
      EdPath.Text:=Dir;
    end;
  end;
end;

procedure TWdMain.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=false;
  SaveScreenShot;
end;

procedure TWdMain.Timer2Timer(Sender: TObject);
begin
  Timer2.Enabled:=false;
  if not WdAide.CkAide.Checked then
    WdAide.ShowModal;
end;

procedure TWdMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Ini_Sauve;
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  //16/9 : Rapport = 1.777
  DirExe:=ExtractFilePath(Application.ExeName);
  if DirExe[Length(DirExe)]<>'\' then
    DirExe:=DirExe+'\';
  Dir:=DirExe;
  //-
  JpegNb:=0;
  Ratio:=1.777;
  Ratio_Ecran;
  //-
  Ini_Lire;
  WdDossier.ShellTreeView1.Path:=Dir;
  EdPath.Text:=WdDossier.ShellTreeView1.Path;
  Timer2.Enabled:=true;
end;

end.

